//------------------------------------------------------------------------
//   15  `tfBXvCtfW^dv`
//             LCD1s: fW^dv(AN0)
//             LCD2s: fW^xv(AN1)
//                                            filename: ex15_dvm.c
//------------------------------------------------------------------------
#include <16f1827.h>
#device ADC=10							// ADϊʂ10rbgŎ擾
#fuses INTRC_IO,NOWDT,NOPROTECT,NOCPD,NOMCLR,NOPUT,BROWNOUT,NOIESO
#fuses NOFCMEN,PLL_SW,NOLVP,NOSTVREN,BORV25
#use delay(clock=8MHZ)					// NbNg8MHz

#include <lcd_lib.h>					// LCDCu֐̃CN[h

//------------------------------------------------------------------------
//          I/O|[g̒`
//------------------------------------------------------------------------
#byte  RA = 0x0c						// |[gA(RA)̃AhX0x0cԒn
#byte  RB = 0x0d						// |[gB(RB)̃AhX0x0dԒn
#define		VREF	4.096				// d 4.096V

//------------------------------------------------------------------------
//          C֐
//------------------------------------------------------------------------
void main(void) {
	long an0;							// long^(2byte)CȂ16rbg
	long an1;							// long^(2byte)CȂ16rbg
	float vt0, tmp;						// t[g()^̕ϐ錾

	setup_oscillator(OSC_8MHZ);			// NbN8MHzɐݒ
	set_tris_a(0xff);					// |[gA͑Sē
	set_tris_b(0x00);					// |[gB͑Sďo
	setup_adc_ports(sAN0 | sAN1 | VSS_FVR);	// AiO͂̓`l0(AN0)C`l1(AN1)Cd
	setup_adc(ADC_CLOCK_DIV_16);		// Fosc/16, ADC:2us
	setup_vref(VREF_ADC_4v096);			// d4.096Vɐݒ

	initlcd();							// LCDW[̏

   while(1) {
	   set_adc_channel(0);				// ADC̓̓`lAN0(dv)ɃZbg
	   delay_us(30);					// ANCW^C̊m
	   an0 = read_adc();				// ADϊX^[gCϊ܂őҋ@CADϊʂ̒l擾
	   vt0 = (float)an0 *(VREF/1024.)*5.0;	// AiOdɕϊ(Hɂ{Z)

	   set_adc_channel(1);				// ADC̓̓`lAN1(xZT)ɃZbg
	   delay_us(30);					// ANCW^C̊m
	   an1 = read_adc();				// ADϊX^[gCϊ܂őҋ@CADϊʂ̒l擾
	   tmp = (float)an1*(VREF/1024.)*100.0;	// AiOdɕϊ(10mV/100{1V/ɕϊ)
	
	   locate(0,0); outst("Vm= "); outf(vt0); outst("[V]   ");
	   locate(0,1); outst("tmp="); outf(tmp); outst("[deg] ");
	   delay_ms(1000);
	}
     }
