//------------------------------------------------------------------------
//   17  `PWM[hɂ郉WRpT[{̐`
//             [PWMg:150Hzn                            PIC16F1827p
//             CCP1o͒[q (CCP1=RB0)
//                                                    filename: ex17_sv.c
//------------------------------------------------------------------------
#include <16f1827.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,NOCPD,NOMCLR,NOPUT,BROWNOUT,NOIESO
#fuses NOFCMEN,PLL_SW,NOLVP,NOSTVREN,BORV25
#use delay(clock=8MHZ)					// NbNg8MHz

//------------------------------------------------------------------------
//          I/O|[g̒`
//------------------------------------------------------------------------
#byte  RA = 0x0c						// |[gA(RA)̃AhX0x0cԒn
#byte  RB = 0x0d						// |[gB(RB)̃AhX0x0dԒn

//------------------------------------------------------------------------
//          C֐
//------------------------------------------------------------------------
void main(void) {
	long dtN, dtR, dtL;					// DCR萔i[p
	setup_oscillator(OSC_8MHZ);			// NbN8MHzɐݒ

	setup_timer_2(T2_DIV_BY_64,207,1);	// TMR2vXP[(64),PR2=207,PWM freq=150Hz
	setup_ccp1(CCP_PWM | CCP_TIMER2 | CCP1_B0);	// CCP1W[PWM[hCPWMTMR2,o͒[qRB0
	
	set_tris_a(0x00);					// |[gA͑Sďo
	set_tris_b(0x00);					// |[gB͑Sďo

	dtN = 190;							// DCR̒萔FNC     1.52ms
	dtR = 115;							// DCR̒萔FCW,     0.92ms
	dtL = 265;							// DCR̒萔FCCW,    2.12ms

	while(1){
	   set_pwm1_duty(dtN); delay_ms(1000);	// CCP1DCRɃf[eB̐ݒ,Neutral
	   set_pwm1_duty(dtR); delay_ms(1000);	// CCP1DCRɃf[eB̐ݒ,ClockWise
	   set_pwm1_duty(dtL); delay_ms(1000);	// CCP1DCRɃf[eB̐ݒ,CounterClockWise
	 }
 }
