//------------------------------------------------------------------------
//   23  GnXgPWM[h `tubW[hɂPWMó`
//          ECCP1o:P1A(RB0), P1B(RB5)CP1C(RA7)CP1D(RA6)
//        [PWMg:10kHz(Timer2)CP1A,P1C:ANeBuLow, P1B,P1D:ANeBuHigh]
//                                                filename: ex23_pwmfull.c
//------------------------------------------------------------------------
#include <16f1827.h>
#fuses INTRC_IO,NOWDT,NOPROTECT,NOCPD,NOMCLR,NOPUT,BROWNOUT,NOIESO
#fuses NOFCMEN,PLL_SW,NOLVP,NOSTVREN,BORV25,NODEBUG
#use delay(clock=16MHZ)					// NbNg16MHz

//------------------------------------------------------------------------
//          萔ƃO[oϐ̒`
//------------------------------------------------------------------------
#define		FW		0					// [^̉](])
#define		REV 	1					// [^̉](t])

int1  f_mdir;							// [^̉]tO, 0:FW,1:REV

//------------------------------------------------------------------------
//          ֐̒`
//------------------------------------------------------------------------
void motor_fw(byte dt1) {				// [^̐]C:f[eB(0`100%)
	long dtf;
	dtf = (long)dt1 * 4;				// (dt1(%)*400/100), %f[eBTCNWX^̐ݒlZo
	if(f_mdir == FW) {					// ]Ԃ̌pȂf[eB̂ݐݒ
	   set_pwm1_duty(dtf);
	 } else {							// t]̖߂Ȃf[eB[ɂ 
	   set_pwm1_duty(0);
	   setup_ccp1(CCP_PWM_FULL_BRIDGE | CCP_PWM_L_H | CCP_P1A_B0 | CCP_P1C_A7 | CCP_P1D_A6 | CCP_TIMER2);
										// tubW][h,P1A,P1C:ANeBuLow; P1B,P1D:ANeBuHigh, Timer2
 	   set_pwm1_duty(dtf);				// f[eB̐ݒ
	   f_mdir = FW;						// [^̉]tO𐳉]ɐݒ
	 } 
 }

void motor_rev(byte dt2) {				// [^̋t]C:f[eB(0`100%)
	long dtr;
	dtr = (long)dt2 * 4;				// (dt2(%)*400/100), %f[eBTCNWX^̐ݒlZo
	if(f_mdir == REV) {					// t]Ԃ̌pȂf[eB̂ݐݒ
	   set_pwm1_duty(dtr);
	 } else {			
	   set_pwm1_duty(0);				// ]̖߂Ȃf[eB[ɂ
	   setup_ccp1(CCP_PWM_FULL_BRIDGE_REV | CCP_PWM_L_H | CCP_P1A_B0 | CCP_P1C_A7 | CCP_P1D_A6 | CCP_TIMER2);
										// tubWt][h,P1A,P1C:ANeBuLow; P1B,P1D:ANeBuHigh, Timer2
 	   set_pwm1_duty(dtr);				// f[eB̐ݒ
	   f_mdir = REV;					// [^̉]tOt]ɐݒ
	 }
 }

void motor_stop(void) {					// [^̒~
	set_pwm1_duty(0);					// f[eB 0%
 }

void motor_brk(void) {					// [^u[L
	if(f_mdir == FW)
	  motor_rev(0);						// ]ԂȂt][hɂăf[eB 0
	else
	  motor_fw(0);						// t]ԂȂ琳][hɂăf[eB 0
 }

//------------------------------------------------------------------------
//          C֐
//------------------------------------------------------------------------
void main(void) {
	setup_oscillator(OSC_16MHZ);		// NbN8MHzɐݒ
	setup_timer_2(T2_DIV_BY_4,99,1);	// TMR2vXP[(4),PR2=99,PWMg=10kHz
	setup_ccp1(CCP_PWM_FULL_BRIDGE | CCP_PWM_L_H | CCP_P1A_B0 | CCP_P1C_A7 | CCP_P1D_A6 | CCP_TIMER2);
	set_pwm1_duty(0);					// l̓f[eB [
	f_mdir = FW;						// [^̉]tȌl͐]
	set_tris_a(0x00);					// |[gA͑Sďo
	set_tris_b(0x00);					// |[gB͑Sďo

   while(1) {
	  motor_fw(80);  delay_ms(2000);	// ](f[eB80)Cԑ҂2b
	  motor_stop();  delay_ms(1000);	// ~              Cԑ҂1b
	  motor_rev(50); delay_ms(2000);	// t](f[eB50)Cԑ҂2b
	  motor_brk();   delay_ms(3000);	// u[L			 Cԑ҂3b
    }
 }

 